import os.path
from PyQt5 import uic
from PyQt5.QtWidgets import QDialog
from PyQt5.QtGui import QDesktopServices
from PyQt5.QtCore import QUrl
from ..b64_conv import B64Convertor


FORM_CLASS, _ = uic.loadUiType(os.path.join(
    os.path.dirname(__file__), 'download_sketch_dlg.ui'))


class DownloadSketch(QDialog, FORM_CLASS):
    def __init__(self, layer, feature):
        super(DownloadSketch, self).__init__()
        self.setupUi(self)
        self.layer = layer
        self.feature = feature

        if self.feature['doc_pdf_parcel_sketch']:
            self.downloadPDFButton.setEnabled(True)
        else:
            self.downloadPDFButton.setEnabled(False)

        if self.feature['doc_png_parcel_sketch']:
            self.downloadPNGButton.setEnabled(True)
        else:
            self.downloadPNGButton.setEnabled(False)

        self.downloadPDFButton.clicked.connect(self.download_slot_pdf)
        self.downloadPNGButton.clicked.connect(self.download_slot_png)

    def download_slot_pdf(self):
        tmpfileurl = B64Convertor.file_from_base64(self.feature["doc_pdf_parcel_sketch"])
        QDesktopServices.openUrl(
            QUrl.fromLocalFile(tmpfileurl))

    def download_slot_png(self):
        tmpfileurl = B64Convertor.file_from_base64(self.feature["doc_png_parcel_sketch"])
        QDesktopServices.openUrl(
            QUrl.fromLocalFile(tmpfileurl))
